/*
	$Id: auth.c,v 1.24 2011/04/18 09:45:28 alex Exp $
	auth.c--- edb_auth
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: auth.c,v 1.24 2011/04/18 09:45:28 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdarg.h>
#include	<string.h>
#include	"edb/edb.h"
#if 0
#include	"libpq/libpq-fs.h"
#endif

#include <sys/types.h>
#include <sys/time.h>
#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <pwd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>

static
struct {
	int	level;
	char	*xmlname;
	char	*english;
	char	*japanese;
} auth_to_xml[] = {
	{	EDB_AUTH_INHERIT,	"inherit",		"Inherit",		"継承"	},
	{	EDB_AUTH_PUBLIC,		"public",		"Public",		"公開"	},
	{	EDB_AUTH_UNIVERSITY,	"university",	"University",	"学内"	},
	{	EDB_AUTH_USER,		"user",		"User",		"ユーザ"	},
	{	EDB_AUTH_PERSONNEL,	"personnel",	"Personnel",	"職員"	},
	{	EDB_AUTH_TEACHER,	"teacher",		"Teacher",		"教員"	},
	{	EDB_AUTH_LIMITED,	"limited",		"Limited",		"制限"	},
	{	EDB_AUTH_OWNER,		"owner",		"Owner",		"所有者"	},
	{	EDB_AUTH_STAFF,		"staff",		"Staff",		"管理者"	},
};

utf8_t *
edb_auth_string(EdbContext ec, int level, int last)
{
	register int	i;

	if(ec->japanese) {
		if(level==EDB_AUTH_PUBLIC) return (utf8_t *)auth_to_xml[last?1:0].japanese;
		for(i=2; i<Ns(auth_to_xml); ++i) {
			if(auth_to_xml[i].level == level) return (utf8_t *)auth_to_xml[i].japanese;
		}
		return (utf8_t *)auth_to_xml[0].japanese;
	} else {
		if(level==EDB_AUTH_PUBLIC) return (utf8_t *)auth_to_xml[last?1:0].english;
		for(i=2; i<Ns(auth_to_xml); ++i) {
			if(auth_to_xml[i].level == level) return (utf8_t *)auth_to_xml[i].english;
		}
		return (utf8_t *)auth_to_xml[0].english;
	}
}

utf8_t *
edb_auth_xmlstring(EdbContext ec, int level, int last)
{
	register int	i;

	if(level==EDB_AUTH_PUBLIC) return (utf8_t *)auth_to_xml[last?1:0].xmlname;
	for(i=2; i<Ns(auth_to_xml); ++i) {
		if(auth_to_xml[i].level == level) return (utf8_t *)auth_to_xml[i].xmlname;
	}
	return (utf8_t *)auth_to_xml[0].xmlname;
}

int
edb_auth_xmlname_to_permission(utf8_t *s, int last)
{
	register int	i;

	s = (utf8_t *)STRDUP((char *)s);
	str_onephrase((char *)s);
	for(i=0; i<Ns(auth_to_xml); ++i) {
		if(!strcasecmp(auth_to_xml[i].xmlname, (char *)s)) return auth_to_xml[i].level;
	}
	return auth_to_xml[0].level;
}

#ifdef	EDB_READER
int	edb_auth_writable(EdbContext ec, eid_t eid) { return FALSE; }
int	edb_auth_writable_by(EdbContext ec, eid_t op, eid_t eid) { return FALSE; }
int	edb_auth_deletable(EdbContext ec, eid_t eid) { return FALSE; }
int	edb_auth_deletable_by(EdbContext ec, eid_t op, eid_t eid) { return FALSE; }
#endif	/* EDB_READER */

