/*
	$Id: base64.c,v 1.5 2008/08/09 09:21:37 alex Exp $
	xml.c--- XML misc command
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: base64.c,v 1.5 2008/08/09 09:21:37 alex Exp $";
#endif

#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	"edb/edb.h"
#include	"edb/base64.h"

#if 0
#define	TRUE	1
#define	FALSE	0
#endif

#define	STRDUP(s)	(strcpy((char *)alloca(sizeof(char)*(strlen(s)+1)), (s)))

static unsigned char	*base64_encode_table = (unsigned char *)"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
static unsigned char	base64_decode_table[256];
static int	base64_decode_table_initialized = FALSE;

#define	BASE64_CPL	64	/* characters per one-line */

unsigned char	*
base64_encode(register unsigned char *s, register int slen)
{
	register unsigned char *dst, *d;
	register int	i, dlen, cnt;

	dlen = ((slen+2)/3)*4;
	dlen += (dlen+BASE64_CPL)/BASE64_CPL;
	dlen += 1;
	dst = (unsigned char *)malloc(sizeof(unsigned char)*dlen);
	d = dst;
	cnt = 0;
	for(i=0; i<slen; i+=3) {
		register unsigned char c1, c2, c3;

		if(cnt>=BASE64_CPL) {
			*d++ = ' ';
			cnt = 0;
		}
		c1 = (i<slen)	? *s++ : 0;
		c2 = (i+1<slen)	? *s++ : 0;
		c3 = (i+2<slen)	? *s++ : 0;
		if(i+2<slen) {
			*d++ = base64_encode_table[(c1>>2)];
			*d++ = base64_encode_table[((c1&0x03)<<4)|(c2>>4)];
			*d++ = base64_encode_table[((c2&0x0F)<<2)|(c3>>6)];
			*d++ = base64_encode_table[(c3&0x3F)];
		} else if(i+1<slen) {
			*d++ = base64_encode_table[(c1>>2)];
			*d++ = base64_encode_table[((c1&0x03)<<4)|(c2>>4)];
			*d++ = base64_encode_table[((c2&0x0F)<<2)|(c3>>6)];
			*d++ = '=';
			break;
		} else {
			*d++ = base64_encode_table[(c1>>2)];
			*d++ = base64_encode_table[((c1&0x03)<<4)|(c2>>4)];
			*d++ = '=';
			*d++ = '=';
			break;
		}
		cnt += 4;
	}
	*d = '\0';
	return dst;
}

unsigned char	*
base64_decode(register unsigned char *s, int *plen)
{
	register unsigned char *dst, *d;
	register int	i, dlen, slen, len;

	if(!base64_decode_table_initialized) {
		for(i=0; i<64; ++i) base64_decode_table[base64_encode_table[i]] = i;
		base64_decode_table_initialized = TRUE;
	}

	s = (unsigned char *)STRDUP((char *)s);
	str_onephrase((char *)s);

	slen = strlen((char *)s);
	dlen = ((slen+3)/4)*3+1;
	dst = (unsigned char *)malloc(sizeof(unsigned char)*dlen);
	d = dst;
	len = 0;
	for(i=0; i<slen; i+=4) {
		register unsigned char	s3, s4;
		register unsigned char	c1, c2, c3, c4;

		c1 = base64_decode_table[(i<slen)	? (*s++) : '='] ;
		c2 = base64_decode_table[(i+1<slen)	? (*s++) : '='] ;
		c3 = base64_decode_table[s3 = (i+2<slen)	? (*s++) : '='] ;
		c4 = base64_decode_table[s4 = (i+3<slen)	? (*s++) : '='] ;
		if(s4!='=') {
			*d++ = (c1<<2)|(c2>>4);
			*d++ = (c2<<4)|(c3>>2);
			*d++ = (c3<<6)|(c4);
			len += 3;
			continue;
		} else if(s3!='=') {
			*d++ = (c1<<2)|(c2>>4);
			*d++ = (c2<<4)|(c3>>2);
			len += 2;
			break;
		} else {
			*d++ = (c1<<2)|(c2>>4);
			len += 1;
			break;
		}
	}
	*d = '\0';
	*plen = len;
	return dst;
}
