/*
$Id: time.c,v 1.7 2006/10/27 12:35:04 alex Exp $
	time.c--- time
	(C) Copyright 1994 by Alex
*/

#ifndef lint
static char *rcsid __attribute__((unused)) = "$Id: time.c,v 1.7 2006/10/27 12:35:04 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<strings.h>
#include	<time.h>
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/resource.h>
#include	"edb/edb.h"

/*#gettime--- get current time (sec) */
int
gettime()
{
	time_t tloc;

	return time(&tloc);
}

/*#getcputime--- get cpu time */
double
getcputime()
{
	struct rusage r;

	bzero(&r, sizeof(struct rusage));
	getrusage(RUSAGE_SELF, &r);
	return (double)r.ru_utime.tv_sec + (double)r.ru_utime.tv_usec / 1000000.0;
}

#if 0
/*#time_to_serial--- time to serial */
time_to_serial(dst, src)
char *dst;
char *src;
{
	int year, mon, day, hour, min, sec;
	int matches;

	matches = sscanf(src, "%4d/%2d/%2d %2d:%2d:%2d",
		&year, &mon, &day, &hour, &min, &sec);
	if(matches == 6) {
		sprintf(dst, "%04d%02d%02d%02d", year, mon, day, hour);
	} else {
		strcpy(dst, "1994010100");
	}
}
#endif

/*#getdatestr--- get date string */
char *
getdatestr(buf)
char *buf;
{
	time_t tloc;
	struct tm tm;

	time(&tloc);
	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	sprintf(buf, "%04d/%02d/%02d %02d:%02d:%02d %s",
		tm.tm_year+1900,
		tm.tm_mon + 1,
		tm.tm_mday,
		tm.tm_hour,
		tm.tm_min,
		tm.tm_sec,
		tm.tm_zone);
	return buf;
}

/*#gettoday_DATE--- */
int
gettoday_DATE()
{
	time_t tloc;
	struct tm tm;
	int	d;

	time(&tloc);
	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	d = (tm.tm_year+1900)*10000+ (tm.tm_mon + 1)*100 + tm.tm_mday;
	return d;
}

/*#gethour--- get hour */
int
gethour()
{
	time_t tloc;
	struct tm tm;

	time(&tloc);
	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	return tm.tm_hour;
}

/*#gettodaystr--- get today string */
char *
gettodaystr(buf)
char *buf;
{
	time_t tloc;
	struct tm tm;

	time(&tloc);
	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	sprintf(buf, "%04d/%02d/%02d",
		tm.tm_year+1900,
		tm.tm_mon + 1,
		tm.tm_mday);
	return buf;
}

/*#getdatestr_before_day--- get date string */
char *
getdatestr_before_day(buf)
char *buf;
{
	time_t tloc;
	struct tm tm;

	time(&tloc);
	tloc -= 60*60*24;
	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	sprintf(buf, "%04d/%02d/%02d %02d:%02d:%02d %s",
		tm.tm_year+1900,
		tm.tm_mon + 1,
		tm.tm_mday,
		tm.tm_hour,
		tm.tm_min,
		tm.tm_sec,
		tm.tm_zone);
	return buf;
}

/*#getdatestr_before_days--- get date string */
char *
getdatestr_before_days(buf, days)
char *buf;
int	days;
{
	time_t tloc;
	struct tm tm;

	time(&tloc);
	tloc -= (time_t)60*60*24*days;
	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	sprintf(buf, "%04d/%02d/%02d %02d:%02d:%02d %s",
		tm.tm_year+1900,
		tm.tm_mon + 1,
		tm.tm_mday,
		tm.tm_hour,
		tm.tm_min,
		tm.tm_sec,
		tm.tm_zone);
	return buf;
}

/*#getdatestr_before_week--- get date string */
char *
getdatestr_before_week(buf)
char *buf;
{
	time_t tloc;
	struct tm tm;

	time(&tloc);
	tloc -= 60*60*24*7;
	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	sprintf(buf, "%04d/%02d/%02d %02d:%02d:%02d %s",
		tm.tm_year+1900,
		tm.tm_mon + 1,
		tm.tm_mday,
		tm.tm_hour,
		tm.tm_min,
		tm.tm_sec,
		tm.tm_zone);
	return buf;
}

/*#getdatestr_before_month--- get date string */
char *
getdatestr_before_month(buf)
char *buf;
{
	time_t tloc;
	struct tm tm;

	time(&tloc);
	tloc -= 60*60*24*30;
	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	sprintf(buf, "%04d/%02d/%02d %02d:%02d:%02d %s",
		tm.tm_year+1900,
		tm.tm_mon + 1,
		tm.tm_mday,
		tm.tm_hour,
		tm.tm_min,
		tm.tm_sec,
		tm.tm_zone);
	return buf;
}

/*#getdatestr_before_year--- get date string */
char *
getdatestr_before_year(buf)
char *buf;
{
	time_t tloc;
	struct tm tm;

	time(&tloc);
	tloc -= 60*60*24*365;
	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	sprintf(buf, "%04d/%02d/%02d %02d:%02d:%02d %s",
		tm.tm_year+1900,
		tm.tm_mon + 1,
		tm.tm_mday,
		tm.tm_hour,
		tm.tm_min,
		tm.tm_sec,
		tm.tm_zone);
	return buf;
}

/*#getdatestr_from_time--- get date string */
char *
getdatestr_from_time(buf, tloc)
char *buf;
time_t tloc;
{
	struct tm tm;

	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	sprintf(buf, "%04d/%02d/%02d %02d:%02d:%02d (%s)",
		tm.tm_year+1900,
		tm.tm_mon + 1,
		tm.tm_mday,
		tm.tm_hour,
		tm.tm_min,
		tm.tm_sec,
		tm.tm_zone);
	return buf;
}

/*#gatdays--- get number of days (from Jan. 1) */
int
getdays()
{
	time_t tloc;
	struct tm tm;

	time(&tloc);
	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	return tm.tm_yday;
}

/*#gatwday--- get kind of days */
int
getwday()
{
	time_t tloc;
	struct tm tm;

	time(&tloc);
	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	return tm.tm_wday;
}

/*#time2datestr--- time to date str */
char *
time2datestr(buf, tloc)
char	*buf;
time_t	tloc;
{
	struct tm tm;

	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	sprintf(buf, "%04d/%02d/%02d %02d:%02d:%02d %s",
		tm.tm_year+1900,
		tm.tm_mon + 1,
		tm.tm_mday,
		tm.tm_hour,
		tm.tm_min,
		tm.tm_sec,
		tm.tm_zone);
	return buf;
}

/*#datestr2time--- datestr to time */
time_t
datestr2time(buf)
char *buf;
{
	struct tm tm;
	char	zone[BUFSIZ];
	int	matches;

	matches = sscanf(buf, "%d/%d/%d %d:%d:%d %s",
		&tm.tm_year,
		&tm.tm_mon,
		&tm.tm_mday,
		&tm.tm_hour,
		&tm.tm_min,
		&tm.tm_sec,
		zone);
	if(matches != 7) return 0;
	tm.tm_year -=1900;
	tm.tm_mon -= 1;
	tm.tm_isdst = 0;
	tm.tm_zone = zone;
	tm.tm_gmtoff = 0;

	return mktime(&tm);
}

/*#datestr2time000000--- datestr to time 00:00:00 */
time_t
datestr2time000000(buf)
char *buf;
{
	struct tm tm;
	char	zone[BUFSIZ];
	int	matches;

	matches = sscanf(buf, "%d/%d/%d %d:%d:%d %s",
		&tm.tm_year,
		&tm.tm_mon,
		&tm.tm_mday,
		&tm.tm_hour,
		&tm.tm_min,
		&tm.tm_sec,
		zone);
	if(matches != 7) return 0;
	tm.tm_year -=1900;
	tm.tm_mon -= 1;
	tm.tm_hour = 0;
	tm.tm_min = 0;
	tm.tm_sec = 0;
	tm.tm_isdst = 0;
	tm.tm_zone = zone;
	tm.tm_gmtoff = 0;

	return mktime(&tm);
}

/*#time2time000000--- time to time 00:00:00 */
time_t
time2time000000(tloc)
time_t	tloc;
{
	struct tm tm;

	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	return tloc - (tm.tm_hour * 60 * 60) - (tm.tm_min * 60) - (tm.tm_sec);
}

/*#time2wsec--- time to week second */
int
time2wsec(tloc)
time_t	tloc;
{
	struct tm tm;

	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	return (((tm.tm_wday*24+tm.tm_hour)*60)+tm.tm_min)*60+tm.tm_sec;
}

/*#time2ysec--- time to week second */
int
time2ysec(tloc)
time_t	tloc;
{
	struct tm tm;

	bcopy(localtime(&tloc), &tm, sizeof(struct tm));
	return (((tm.tm_yday*24+tm.tm_hour)*60)+tm.tm_min)*60+tm.tm_sec;
}


