/*
	$Id: trace.c,v 1.9 2009/07/31 11:26:47 alex Exp $
	trace.c--- trace
*/

#ifndef	lint
static char *rcsid __attribute__((unused)) = "$Id: trace.c,v 1.9 2009/07/31 11:26:47 alex Exp $";
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<syslog.h>
#include	"edb/edb.h"

FILE *
edb_trace_set(EdbContext ec, FILE *fp)
{
	FILE	*fp_bak;

	fp_bak = ec->trace;
	ec->trace = fp;
	return fp_bak;
}

int
edb_trace(EdbContext ec, char *fmt, ...)
{
	va_list	ap;
	int	n = 0;

	if(ec->trace) {
		va_start(ap, fmt);
		n = vfprintf(ec->trace, fmt, ap);
		va_end(ap);
	}

	return n;
}

int
edb_trace_to_syslog(EdbContext ec, char *fmt, ...)
{
	va_list	ap;
	int	n = 0;
	char	*s;

	va_start(ap, fmt);
	vasprintf(&s, fmt, ap);
	va_end(ap);
	openlog("edb", LOG_PID, LOG_DAEMON);
	syslog(LOG_NOTICE, "PG=[%d]: %s.", edb_pgsql_pid(ec), s);
	closelog();
	FREE(s);

	return n;
}

int
edb_trace_flush(EdbContext ec)
{

	if(ec->trace) return fflush(ec->trace);
	return 0;
}

int
edb_trace_time(EdbContext ec, char *fmt, ...)
{
	va_list	ap;
	int	n = 0;

	if(ec->trace && ec->trace_time) {
		struct timeval	tv, t;

		gettimeofday(&tv, NULL);
		timersub(&tv, &ec->configured_time, &t);
		fprintf(ec->trace, "%ld.%06ld : ", t.tv_sec, (long int)t.tv_usec);
		va_start(ap, fmt);
		n = vfprintf(ec->trace, fmt, ap);
		va_end(ap);
	}

	return n;
}


